=== debian/changelog ===
cgal (4.0-2) unstable; urgency=low

  * Add patch gcc-4.7 to fix a syntax error in template code which is
    not instantiated during the package build itself (Closes: #673554).
  * Fix debian/watch.

 -- Joachim Reichel <reichel@debian.org>  Sun, 20 May 2012 22:47:56 +0200

cgal (4.0-1) unstable; urgency=low

  * New upstream release.
  * Move from non-free to main due to upstream license change from QPL
    to GPL 3+ (and from LGPL 2.1 to LGPL 3+), updated debian/copyright
    accordingly.
  * Rename binary package libcgal8 to libcgal9 to reflect SONAME change.
  * Update Standards-Version to 3.9.3 (no changes needed).
  * Remove fix-ipe-version-detection.dpatch and
    fix-qt-moc-parse-error.dpatch (fixed upstream).
  * Removed libmagick++9-dev from Suggests: of libcgal-demo, because
    that package does no longer exists.

 -- Joachim Reichel <reichel@debian.org>  Mon, 12 Mar 2012 19:14:55 +0100

cgal (3.9-4) unstable; urgency=low

  * Rebuild against boost 1.48 (Closes: #659358).
  * Add fix-qt-moc-parse-error.dpatch as workaround for
    https://bugreports.qt-project.org/browse/QTBUG-22829.

 -- Joachim Reichel <reichel@debian.org>  Fri, 10 Feb 2012 22:41:26 +0100
