=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	mkdir -p static
	cd static && QTDIR= cmake .. \
	  -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release \
	  -DCMAKE_SKIP_RPATH=TRUE -DBUILD_SHARED_LIBS=FALSE \
	  -DWITH_CGAL_Qt3=OFF -DWITH_demos=OFF -DWITH_examples=OFF
	mkdir -p shared
	cd shared && QTDIR= cmake .. \
	  -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release \
	  -DCMAKE_SKIP_RPATH=TRUE -DBUILD_SHARED_LIBS=TRUE \
	  -DWITH_CGAL_Qt3=OFF -DWITH_demos=OFF -DWITH_examples=OFF
	mkdir -p shared/demo/CGAL_ipelets
	cd shared/demo/CGAL_ipelets && QTDIR= cmake ../../../demo/CGAL_ipelets \
	  -DCMAKE_VERBOSE_MAKEFILE=ON -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_BUILD_TYPE=Release \
	  -DCMAKE_SKIP_RPATH=TRUE -DBUILD_SHARED_LIBS=TRUE \
	  -DWITH_CGAL_Qt3=OFF -DCGAL_DIR=$(CURDIR)/shared   

override_dh_auto_build:
	$(MAKE) -C static
	$(MAKE) -C shared
	$(MAKE) -C shared/demo/CGAL_ipelets

override_dh_auto_test:
ifneq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) -C debian/tests IEEE_FPU_OPTION="$(IEEE_FPU_OPTION)" rounding_modes1
	LD_LIBRARY_PATH=shared/lib debian/tests/rounding_modes1
	$(MAKE) -C debian/tests IEEE_FPU_OPTION="$(IEEE_FPU_OPTION)" rounding_modes2
	LD_LIBRARY_PATH=shared/lib debian/tests/rounding_modes2
endif

override_dh_auto_clean:
	dh_auto_clean
	rm -fr shared static

override_dh_install:
	$(MAKE) -C static DESTDIR=$(CURDIR)/debian/tmp install
	$(MAKE) -C shared DESTDIR=$(CURDIR)/debian/tmp install
	$(MAKE) -C shared/demo/CGAL_ipelets DESTDIR=$(CURDIR)/debian/tmp install

	mkdir -p debian/tmp/usr/share/cmake-2.8/Modules
	cp cmake/modules/FindCGAL.cmake debian/tmp/usr/share/cmake-2.8/Modules

	mv debian/tmp/usr/share/doc/CGAL-`cat VERSION` debian/tmp/usr/share/doc/cgal
	mv debian/tmp/usr/share/doc/cgal/CHANGES debian/tmp/usr/share/doc/cgal/changelog
	rm debian/tmp/usr/share/doc/cgal/LICENSE*
	rm debian/tmp/usr/share/doc/cgal/AUTHORS

	tar cf - examples | gzip --best >debian/tmp/usr/share/doc/cgal/examples.tar.gz
	tar cf - demo | gzip --best >debian/tmp/usr/share/doc/cgal/demo.tar.gz

	rm debian/tmp/usr/bin/cgal_make_macosx_app

	dh_install --sourcedir=debian/tmp --list-missing

	mkdir -p debian/libcgal-demo/usr/share/doc
	ln -s libcgal9 debian/libcgal-demo/usr/share/doc/libcgal-demo
	mkdir -p debian/libcgal-dev/usr/share/doc
	ln -s libcgal9 debian/libcgal-dev/usr/share/doc/libcgal-dev
	mkdir -p debian/libcgal-ipelets/usr/share/doc
	ln -s libcgal9 debian/libcgal-ipelets/usr/share/doc/libcgal-ipelets

override_dh_installdocs:
	dh_installdocs -plibcgal9 debian/copyright

override_dh_installchangelogs:
	dh_installchangelogs -plibcgal9

override_dh_shlibdeps:
	dh_shlibdeps -a -ldebian/libcgal9/usr/lib

override_dh_gencontrol:
	dh_gencontrol -- -VIpe-Version=`dpkg-awk 'Package:^ipe$$' -- Version | grep Version | sed 's/Version: //;s/-[^-]*$$//'`
